Program MPI_IO
Use MPI
Implicit None
Integer :: wsize,wrank
Integer :: ierror
Integer :: fh
Integer(Kind=MPI_OFFSET_KIND) :: displacement
Integer :: status(MPI_STATUS_SIZE)
Call MPI_Init(ierror)
Call MPI_Comm_rank(MPI_COMM_WORLD,wrank,ierror)
Call MPI_File_open(MPI_COMM_WORLD,"myfile.dat",MPI_MODE_CREATE+MPI_MODE_RDWR,MPI_INFO_NULL,fh,ierror)
displacement=wrank*4
Call MPI_File_set_view(fh,displacement,MPI_INTEGER, MPI_INTEGER, "native", MPI_INFO_NULL, ierror)
Call MPI_File_write_all(fh,wrank,1,MPI_INTEGER,status,ierror)
Call MPI_File_close(fh,ierror)
Call MPI_Comm_size(MPI_COMM_WORLD,wsize,ierror)
Call MPI_Finalize(ierror)
End Program MPI_IO

