Program MPI_IO
Use MPI
Implicit None
Integer :: wsize,wrank
Integer :: ierror
Integer :: fh
Integer(Kind=MPI_OFFSET_KIND) :: displacement
Integer :: status(MPI_STATUS_SIZE)
Integer :: sizes(2), subsizes(2), starts(2)
Integer :: ranknum(2,2)
Integer :: subarray
Call MPI_Init(ierror)
Call MPI_Comm_rank(MPI_COMM_WORLD,wrank,ierror)
Call MPI_Comm_size(MPI_COMM_WORLD,wsize,ierror)
Call MPI_File_open(MPI_COMM_WORLD,"myfile.dat",MPI_MODE_CREATE+MPI_MODE_RDWR,MPI_INFO_NULL,fh,ierror)
sizes=(/ wsize, 4 /)
subsizes=(/ 2, 2/)
starts=(/ 2*(wrank/2), 2*Mod(wrank,2) /)
Call MPI_Type_create_subarray(2,sizes,subsizes,starts,MPI_ORDER_FORTRAN,MPI_INTEGER,subarray,ierror)
Call MPI_Type_commit(subarray,ierror)
ranknum(:,:)=wrank
displacement=0
Call MPI_File_set_view(fh,displacement,MPI_INTEGER, subarray, "native", MPI_INFO_NULL, ierror)
Call MPI_File_write_all(fh,ranknum,4,MPI_INTEGER,status,ierror)
Call MPI_File_close(fh,ierror)
Call MPI_Finalize(ierror)
End Program MPI_IO

